Bug 669638 - %_smp_mflags enforces a limit of 16 CPUs
Summary: %_smp_mflags enforces a limit of 16 CPUs
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Red Hat Enterprise Linux 6
Classification: Red Hat
Component: redhat-rpm-config
Version: 6.0
Hardware: Unspecified
OS: Unspecified
medium
medium
Target Milestone: rc
: ---
Assignee: Panu Matilainen
QA Contact: Michal Trunecka
URL:
Whiteboard:
Depends On:
Blocks: 682670 905552
TreeView+ depends on / blocked
 
Reported: 2011-01-14 08:38 UTC by Jon Masters
Modified: 2014-09-30 23:33 UTC (History)
4 users (show)

Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Clone Of:
: 905552 (view as bug list)
Environment:
Last Closed: 2013-02-21 10:57:57 UTC


Attachments (Terms of Use)


Links
System ID Priority Status Summary Last Updated
Red Hat Product Errata RHBA-2013:0460 normal SHIPPED_LIVE redhat-rpm-config bug fix and enhancement update 2013-02-20 21:07:27 UTC

Description Jon Masters 2011-01-14 08:38:57 UTC
Description of problem:

You'll notice in the kernel SPEC file that BuildKernel does:

make -s ARCH=$Arch V=1 %{?_smp_mflags} $MakeTarget %{?sparse_mflags}

The value of %smp_mflags is determined (correctly) per architecture
in /usr/lib/rpm/platform/arch-linux/macros by calling e.g.:

/usr/bin/getconf _NPROCESSORS_ONLN

However, then, the top level redhat-rpm-config provided macros override
this with the following:

%_smp_mflags %([ -z "$RPM_BUILD_NCPUS" ] \\\
        && RPM_BUILD_NCPUS="`/usr/bin/getconf _NPROCESSORS_ONLN`"; \\\
        if [ "$RPM_BUILD_NCPUS" -gt 16 ]; then echo "-j16"; \\\
        elif [ "$RPM_BUILD_NCPUS" -gt 1 ]; then echo "-j
$RPM_BUILD_NCPUS"; fi)

So you can never have greater than -j16. Does anyone know if there's a
reason for this, or is it something we want to get urgently fixed?

Jon.

Comment 1 Jon Masters 2011-01-16 02:02:30 UTC
I consider this worth fixing in RHEL6.1. I get the Fedora arguments, but I don't think they apply to RHEL.

Comment 2 Panu Matilainen 2011-03-23 12:41:29 UTC
Reassigning back to reporter as Jon is handling the r-r-c errata for 6.1...

As for the issue itself, I fail to see why any issues here in Fedora would not be applicaple to RHEL as well... but we're not going to find out by speculating.

Comment 4 Jon Masters 2011-06-07 02:10:20 UTC
I'm planning just to remove the 16 limit.

Comment 5 RHEL Product and Program Management 2011-07-05 23:59:32 UTC
This request was evaluated by Red Hat Product Management for
inclusion in the current release of Red Hat Enterprise Linux.
Because the affected component is not scheduled to be updated
in the current release, Red Hat is unfortunately unable to
address this request at this time. Red Hat invites you to
ask your support representative to propose this request, if
appropriate and relevant, in the next release of Red Hat
Enterprise Linux. If you would like it considered as an
exception in the current release, please ask your support
representative.

Comment 6 Jon Masters 2011-07-27 09:04:39 UTC
Reconsider for 6.3. Not at all urgent.

Comment 12 Dennis Gilmore 2012-07-10 10:37:28 UTC
the reason that I added the 16 cpu limit was becase on the fedora sparc builders we were getting build failures where objects would be built out of order with -j32 limiting to 24 did not help it was only when dropped to 16 that we did not see issues. its likely make bugs that were to blame. but building and linking as few as 2 objects could get messed up. ive been meaning to add a %_max_smp_mflags macro that would let a developer fully utilise all available cores.

Comment 13 Panu Matilainen 2012-08-07 14:28:26 UTC
Mmh... how about macroizing the actual limit instead? Something like (untested):

%_smp_ncpus_max 16
%_smp_mflags %([ -z "$RPM_BUILD_NCPUS" ] \\\
        && RPM_BUILD_NCPUS="`/usr/bin/getconf _NPROCESSORS_ONLN`"; \\\
        if [ "$RPM_BUILD_NCPUS" -gt %{_smp_ncpus_max} ]; then echo "-j%{_smp_ncpus_max}"; \\\
        elif [ "$RPM_BUILD_NCPUS" -gt 1 ]; then echo "-j$RPM_BUILD_NCPUS"; fi)

That way the limit is overridable on per-system and per-user basis without having to change the specs, and also overridable within a spec.

Comment 14 Panu Matilainen 2012-08-22 13:19:23 UTC
Shrug... devel_ack, I'll add something similar to the above example.

Comment 19 errata-xmlrpc 2013-02-21 10:57:57 UTC
Since the problem described in this bug report should be
resolved in a recent advisory, it has been closed with a
resolution of ERRATA.

For information on the advisory, and where to find the updated
files, follow the link below.

If the solution does not work for you, open a new bug report.

http://rhn.redhat.com/errata/RHBA-2013-0460.html


Note You need to log in before you can comment on or make changes to this bug.